//----------------------------------------------------------------------------
// This macro puts a date stamp in format YYYYMMDD into columns 73 through 80.
//
// To date stamp one line, put label '.A' on that line.
//
// To date stamp a block of lines, put label '.A' on first line,
// put label '.B' on last line.
//
// Parameter 1:  Optional, specifies date in form YYYYMMDD
//               If not specified, today's date is used.
//
//----------------------------------------------------------------------------
void datestamp(int argc, char *argv[]) {

  char *final_date; // date in form YYYYMMDD
  char *date_str;
  char *year;
  char *month;
  char *day;
  char *text;
  char *label;
  char *pcmd;
  int   linenum1, linenum2;
  int   line_count;
  int   stamp_count;

  if (argc == 2) {
    final_date = argv[1];               // user specified YYYYMMDD
  }
  if (strlen(final_date < 8) {
    date_str = Date();                  // get date in form "YYYY MM DD HH MM SS"
    year  = strgetsubstr(date_str,1,4); // extract YYYY
    month = strgetsubstr(date_str,6,2); // extract MM
    day   = strgetsubstr(date_str,9,2); // extract DD
    final_date = strcompose(year,month,day); // compose final date
  }
  spfservice("cmd","locate .a");
  spfservice("set","cursor_row","1");
  spfservice("set","col_number","1");
  linenum1 = spfservice("query","line_number");
  label    = spfservice("query","line_label",linenum1);
  if (strcmp(label,".A") == 0) {
    spfservice("cmd","locate .b");
    spfservice("set","cursor_row","1");
    spfservice("set","col_number","1");
    linenum2 = spfservice("query","line_number");
    label    = spfservice("query","line_label",linenum2);
    if (strcmp(label,".B") == 0) {
      if (linenum2 > linenum1) {
        line_count = linenum2 - linenum1 + 1;
        }
      else {
        line_count = 0;
        msg("Label '.A' must be on a line above label '.B'");
      }
      }
    else {
      //----------------------------------
      // only one label, just do that line
      //----------------------------------
      line_count = 1;
    }
    if (line_count > 0) {
      stamp_count = 1;
      while (stamp_count <= line_count) {
        pcmd = strcompose("locate ",linenum1);
        spfservice("cmd",pcmd);                 // locate next line in block
        text = spfservice("query","line_data"); // get current line data
        while (strlen(text) < 80) {
          strcat(text," ");                     // pad line data to full length
        }
        strovlsubstr(text,final_date,73);       // put date in cols 73->80
        spfservice("set","line_data",text);     // set new line data
        ++stamp_count;
        ++linenum1;
      } // while
      spfservice("cmd","locate .a");            // reposition to top of block
      spfservice("cmd","reset label");          // clear labels
    }
    }
  else {
    msg("To date stamp one line, put label '.A' on that line.\n\nTo date stamp a block of lines, put label '.A' on first line, put label '.B' on last line.");
  }

} // datestamp
