//-------------------------------------------------------------------------
// Macro: EACHFILE
//
// Parameters: none
//
// Function:
//
//   This macro is invoked as an IMACRO when file FILELIST.TXT is created
//   and edited by batch file ALLFILES.BAT. It parses the current edit file
//   to extract individual file names and apply a series of operations to
//   each file in the list.
//
//-------------------------------------------------------------------------
void EachFile(void) {
 
  char *command;
  char *text;
  char *first_char;
  char *elements[];
  char *path;
  char *filename;
  char *filespec;
  char *try_string;
   
  int   cur_linenum = 1;
  int   last_linenum;
  int   textlen;
   
  trace("on");
  // Set IMACRO name for individual file edits. (see block comment below)
  SPFservice("vput","ZIMACRO","applyops");
  last_linenum = SPFservice("query","line_count");
  while (cur_linenum <= last_linenum) {
    // for each record in file
    command = StrCompose("locate ",cur_linenum);
    SPFservice("cmd",command);                     // position to line
    textlen = SPFservice("query","line_length");   // get line length
    if (textlen > 0) {
      text = SPFservice("query","line_data");      // get line data
      first_char = StrGetSubstr(text,1,1);         // get first char of line 
      if (first_char != " ") {
        StrParse(elements,text," ");               // parse file list enttry elements
        filename = StrCompose(elements[0],".",elements[1]); // copose file name
        filespec = StrCompose(path,"\\",filename); // compose file spec
        //----------------------------------------------------------------
        // At this point we have a fully qualified file name. We will now
        // invoke edit against this file applyinng IMACRO "APPLYOPS" to it
        // which performs the desired operations.
        //
        // NOTE: You must write APPLYOPS.C to perform desired operations.
        //       The last instruction in APPLYOPS.C must be:
        //
        //       SPFservice("cmd","end"); // end edit after ops applied
        //
        //----------------------------------------------------------------
        command = StrCompose("edit ",filespec);
        SPFservice("cmd",command);
        }
      else {
        try_string = StrGetSubstr(text,2,9);       // get possible "Directory" string
        if (try_string == "Directory") {
          path = StrGetSubstr(text,15,256);        // remember path
        }
      }
    }
    ++cur_linenum;
  } // while
  SPFservice("vput","ZIMACRO",""); // reset
   
} // EachFile
